=== debian/changelog ===
hyperscan (4.4.1-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
    Closes: #858887
  * Use stricter versioning on libsqlite3-dev dependency.
  * Add myself to uploaders.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 28 Mar 2017 11:49:10 +0200

hyperscan (4.4.1-1) unstable; urgency=medium

  * Fix overlong changelog line to please lintian
  * Remove explicit FAT_RUNTIME cmake directive
  * New upstream version 4.4.1

 -- Robert Haist <rhaist@mailbox.org>  Sat, 04 Mar 2017 17:06:09 +0100
