=== debian/control ===
Source: hyperscan
Priority: optional
Maintainer: Robert Haist <rhaist@mailbox.org>
Uploaders: Hilko Bengen <bengen@debian.org>,
           Sascha Steinbiss <satta@debian.org>
Build-Depends: debhelper (>=9),
               cmake (>=2.8.11),
               ragel (>=6.9),
#               libboost-dev (>=1.55),
               python (>=2.7),
               po-debconf,
               libsqlite3-dev (>> 3.8.10),
               pkg-config
Standards-Version: 3.9.8
Section: libs
Homepage: https://01.org/hyperscan
Vcs-Git: https://anonscm.debian.org/cgit/collab-maint/hyperscan.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/hyperscan.git

Package: libhyperscan-dev
Section: libdevel
Architecture: any-i386 any-amd64
Depends: libhyperscan4 (= ${binary:Version}), ${misc:Depends}
Description: Development files for the Hyperscan library
 This package contains development libraries, header files and documentation for
 the regular expression matching library libhyperscan. You can either use the
 supplied shared or static library.
 .
 libhyperscan only runs on processors with at least SSSE3 support.

Package: libhyperscan4
Architecture: any-i386 any-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: debconf
Description: High-performance regular expression matching library
 Hyperscan is a high-performance multiple regex matching library.
 It follows the regular expression syntax of the commonly-used libpcre library,
 but is a standalone library with its own C API. Hyperscan uses hybrid automata
 techniques to allow simultaneous matching of large numbers (up to tens of
 thousands) of regular expressions and for the matching of regular expressions
 across streams of data. Hyperscan is typically used in a DPI library stack.
 .
 libhyperscan only runs on processors with at least SSSE3 support.
