=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel

override_dh_auto_clean:
	rm -f $(CURDIR)/include/boost

# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
override_dh_auto_configure:
	ln -s $(CURDIR)/debian/boost_additional/boost $(CURDIR)/include
	dh_auto_configure -- \
		-DBUILD_STATIC_AND_SHARED=1 \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_install:
	dh_install --fail-missing
