## hyperscan 4.5.0

=== debian/changelog ===
hyperscan (4.5.0-1) unstable; urgency=medium

  * Add portuguese translations thanks to Rui Branco (Closes: #859334)
  * New upstream version 4.5.0
  * Fix multiarch directory changes and new example file location

 -- Robert Haist <rhaist@mailbox.org>  Mon, 12 Jun 2017 21:22:30 +0200
