=== debian/changelog ===
hyperscan (4.5.1-1) unstable; urgency=medium

  [ Sascha Steinbiss ]
  * Non-maintainer upload.
  * Fix FTBFS on kFreeBSD.
  * Remove hurd-i386 from list of supported archs.

  [ Robert Haist ]
  * New upstream version 4.5.1
  * Remove patch because it went upstream

 -- Robert Haist <rhaist@mailbox.org>  Fri, 16 Jun 2017 21:32:48 +0200
