=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: hyperscan
 Priority: optional
 Maintainer: Robert Haist <rhaist@mailbox.org>
-Uploaders: Hilko Bengen <bengen@debian.org>,
-           Sascha Steinbiss <satta@debian.org>
+Uploaders: Hilko Bengen <bengen@debian.org>
 Build-Depends: debhelper (>=9),
                cmake (>=2.8.11),
                ragel (>=6.9),
-#               libboost-dev (>=1.55),
+               libboost-dev (>=1.57),
                python (>=2.7),
                po-debconf,
-               libsqlite3-dev (>> 3.8.10),
+               libsqlite3-dev,
                pkg-config
 Standards-Version: 3.9.8
 Section: libs
@@ -19,7 +18,7 @@
 
 Package: libhyperscan-dev
 Section: libdevel
-Architecture: any-i386 any-amd64
+Architecture: i386 kfreebsd-i386 any-amd64
 Depends: libhyperscan4 (= ${binary:Version}), ${misc:Depends}
 Description: Development files for the Hyperscan library
  This package contains development libraries, header files and documentation for
@@ -29,7 +28,7 @@
  libhyperscan only runs on processors with at least SSSE3 support.
 
 Package: libhyperscan4
-Architecture: any-i386 any-amd64
+Architecture: i386 kfreebsd-i386 any-amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: debconf
 Description: High-performance regular expression matching library
