=== debian/changelog ===
hyperscan (4.5.2-1) unstable; urgency=medium

  * New upstream version 4.5.2
  * Bump debian standards versionto 4.0.0

 -- Robert Haist <rhaist@mailbox.org>  Wed, 26 Jul 2017 20:55:04 +0200
