=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                po-debconf,
                libsqlite3-dev,
                pkg-config
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Section: libs
 Homepage: https://01.org/hyperscan
 Vcs-Git: https://anonscm.debian.org/cgit/collab-maint/hyperscan.git
