=== debian/changelog ===
hyperscan (4.6.0-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Robert Haist <rhaist@mailbox.org>  Sat, 30 Sep 2017 23:36:28 +0200

hyperscan (4.6.0-1) unstable; urgency=medium

  * New upstream version 4.6.0
  * Add AVX512 optimisations to fat runtime

 -- Robert Haist <rhaist@mailbox.org>  Sun, 24 Sep 2017 22:22:11 +0200
