=== debian/rules ===
--- 
+++ 
@@ -9,16 +9,14 @@
 %:
 	dh $@ --parallel
 
-override_dh_auto_clean:
-	rm -f $(CURDIR)/include/boost
 
 # dh_make generated override targets
 # This is example for Cmake (See https://bugs.debian.org/641051 )
 override_dh_auto_configure:
-	ln -s $(CURDIR)/debian/boost_additional/boost $(CURDIR)/include
 	dh_auto_configure -- \
 		-DBUILD_STATIC_AND_SHARED=1 \
-		-DCMAKE_BUILD_TYPE=RelWithDebInfo
+		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
+		-DBUILD_AVX512=on
 
 override_dh_install:
 	dh_install --fail-missing
